/************************************************************************
 * This program is a command-line science calculator.                   *
 * It is free software.                                                 *

 * Copyright 2008  Christopher Olah  (christopherolah.co@gmail.com)     *

 * This program is free software; you can redistribute it and/or        *
 * modify it under the terms of the GNU General Public License as       *
 * published by the Free Software Foundation; either version 2 of       *
 * the License, or (at your option) any later version.                  *

 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *

 * You should have received a copy of the GNU General Public License    *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.*
 ************************************************************************/

#include <iostream>
#include <cstdlib>
#include <string>
#include <readline/readline.h>
#include <readline/history.h>

#include "solver.h"

using namespace std;


void interactive() {
	fstring input;
	solver s;
	while (true) {
		char *buffer = readline("\033[1;34m--->\033[0m");
		add_history(buffer);
		input = buffer;
		free(buffer);
		if (input == "q" || input == "quit"){
			return;
		}else {
			cout << s.solve(input.str());
			if (s.error == true) {
				cout << "(Bad Syntax: Potential Error)" << endl;
			}
		}
		input.clear();
	}
	return;
}

void stream(fstring input) {
	fstring stream;
	solver s;
	while (cin >> stream.content) {
		stream=s.solve(stream.str());
		while(!stream.atend()){
			s.s=atof(stream.get_till('\n').str().c_str());
			input.skip();
			cout << s.solve(input.str());
		}
	}
	return;
}

int main(int arg_num, char * args[]) {
	fstring argument;
	argument=args[1];
	if      (arg_num == 1   ) { interactive();   }
	else if (args[1] == "-i") { interactive();   }
	else                      { stream(argument); }
	return 0;
}


